hdu 1026 Ignatius and the Princess I bfs+优先级队列

Ignatius and the Princess I

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 10388    Accepted Submission(s): 3146
Special Judge


Problem Description
The Princess has been abducted by the BEelzebub feng5166, our hero Ignatius has to rescue our pretty Princess. Now he gets into feng5166's castle. The castle is a large labyrinth. To make the problem simply, we assume the labyrinth is a N*M two-dimensional array which left-top corner is (0,0) and right-bottom corner is (N-1,M-1). Ignatius enters at (0,0), and the door to feng5166's room is at (N-1,M-1), that is our target. There are some monsters in the castle, if Ignatius meet them, he has to kill them. Here is some rules:

1.Ignatius can only move in four directions(up, down, left, right), one step per second. A step is defined as follow: if current position is (x,y), after a step, Ignatius can only stand on (x-1,y), (x+1,y), (x,y-1) or (x,y+1).
2.The array is marked with some characters and numbers. We define them like this:
. : The place where Ignatius can walk on.
X : The place is a trap, Ignatius should not walk on it.
n : Here is a monster with n HP(1<=n<=9), if Ignatius walk on it, it takes him n seconds to kill the monster.

Your task is to give out the path which costs minimum seconds for Ignatius to reach target position. You may assume that the start position and the target position will never be a trap, and there will never be a monster at the start position.
 


 

Input
The input contains several test cases. Each test case starts with a line contains two numbers N and M(2<=N<=100,2<=M<=100) which indicate the size of the labyrinth. Then a N*M two-dimensional array follows, which describe the whole labyrinth. The input is terminated by the end of file. More details in the Sample Input.
 


 

Output
For each test case, you should output "God please help our poor hero." if Ignatius can't reach the target position, or you should output "It takes n seconds to reach the target position, let me show you the way."(n is the minimum seconds), and tell our hero the whole path. Output a line contains "FINISH" after each test case. If there are more than one path, any one is OK in this problem. More details in the Sample Output.
 


 

Sample Input
  
  
5 6 .XX.1. ..X.2. 2...X. ...XX. XXXXX. 5 6 .XX.1. ..X.2. 2...X. ...XX. XXXXX1 5 6 .XX... ..XX1. 2...X. ...XX. XXXXX.
 


 

Sample Output
  
  
It takes 13 seconds to reach the target position, let me show you the way. 1s:(0,0)->(1,0) 2s:(1,0)->(1,1) 3s:(1,1)->(2,1) 4s:(2,1)->(2,2) 5s:(2,2)->(2,3) 6s:(2,3)->(1,3) 7s:(1,3)->(1,4) 8s:FIGHT AT (1,4) 9s:FIGHT AT (1,4) 10s:(1,4)->(1,5) 11s:(1,5)->(2,5) 12s:(2,5)->(3,5) 13s:(3,5)->(4,5) FINISH It takes 14 seconds to reach the target position, let me show you the way. 1s:(0,0)->(1,0) 2s:(1,0)->(1,1) 3s:(1,1)->(2,1) 4s:(2,1)->(2,2) 5s:(2,2)->(2,3) 6s:(2,3)->(1,3) 7s:(1,3)->(1,4) 8s:FIGHT AT (1,4) 9s:FIGHT AT (1,4) 10s:(1,4)->(1,5) 11s:(1,5)->(2,5) 12s:(2,5)->(3,5) 13s:(3,5)->(4,5) 14s:FIGHT AT (4,5) FINISH God please help our poor hero. FINISH

 

 

第一眼看到题目 天真的以为 暴力DFS就可以了。。。后来看了代码 才发现用的是bfs。。  自己之前没接触过优先级队列。。顿时觉得自己是村儿里人了。。

优先级队列。。  是个好东西。。。 那这题就没什么难度了。。。我调试了好久才发现出现问题了地方。。

(STL是个好东西 多用用不错。。)

 

#include<iostream>
#include<cstring>
#include<cstdio>
#include<string>
#include<algorithm>
#include<queue>

using namespace std;

int dir[4][2]={{1,0},{-1,0},{0,1},{0,-1}};//下上右左
char g[110][110];
bool vis[110][110];
int n,m;
struct node
{
    int x,y;
    int t;
    int id,pre;
    bool operator <(const node &a)const
    {
        return t>a.t;
    }
}que[10010];
int en;

bool jud(int x,int y)
{
    if(x<0||x>=n) return false;
    if(y<0||y>=m) return false;
    if(vis[x][y]||g[x][y]=='X')
        return false;
    return true;
}

int bfs()
{
    int x,y;
    priority_queue<node> q;
    node a;
    en=0;
    que[en].x=0,que[en].y=-1,que[en].t=-1;
    que[en].id=0,que[en].pre=-1;
    q.push(que[en++]);
    memset(vis,0,sizeof(vis));
    while(!q.empty())
    {
        a=q.top();
        q.pop();
        for(int i=0;i<4;i++)
        {
            x=a.x+dir[i][0];
            y=a.y+dir[i][1];
            if(jud(x,y))
            {
                que[en].x=x;
                que[en].y=y;
                que[en].id=en;
                que[en].t=a.t+(g[x][y]=='.'?1:g[x][y]-'0'+1);
                que[en].pre=a.id;
                if(x==n-1 && y==m-1)
                    return en;
                q.push(que[en++]);
                vis[x][y]=1;
            }
        }
    }
    return -1;
}

void out(int id)
{
    int pre=que[id].pre;
    int x=que[id].x;
    int y=que[id].y;
    int px=que[pre].x;
    int py=que[pre].y;
    if(que[id].pre==1)
    {
        printf("%ds:(%d,%d)->(%d,%d)\n",que[pre].t+1,px,py,x,y);
        if(g[x][y]!='.')
        {
            int t=g[x][y]-'0';
            for(int i=1;i<=t;i++)
                printf("%ds:FIGHT AT (%d,%d)\n",que[pre].t+i+1,x,y);
        }
    }
    else
    {
        out(pre);
        printf("%ds:(%d,%d)->(%d,%d)\n",que[pre].t+1,px,py,x,y);
        if(g[x][y]!='.')
        {
            int t=g[x][y]-'0';
            for(int i=1;i<=t;i++)
                printf("%ds:FIGHT AT (%d,%d)\n",que[pre].t+i+1,x,y);
        }
    }
}

int main()
{
    while(~scanf("%d%d",&n,&m))
    {
        gets(g[0]);
        for(int i=0;i<n;i++)
            gets(g[i]);
        int id=bfs();
        if(id!=-1)
        {
            printf("It takes %d seconds to reach the target position, let me show you the way.\n",que[id].t);
            out(id);
            printf("FINISH\n");
        }
        else
            printf("God please help our poor hero.\nFINISH\n");
    }
    return 0;
}


 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
对于HDU4546问题,还可以使用优先队列(Priority Queue)来解决。以下是使用优先队列的解法思路: 1. 首先,将数组a进行排序,以便后续处理。 2. 创建一个优先队列(最小堆),用于存储组合之和的候选值。 3. 初始化优先队列,将初始情况(即前0个数的组合之和)加入队列。 4. 开始从1到n遍历数组a的元素,对于每个元素a[i],将当前队列中的所有候选值取出,分别加上a[i],然后再将加和的结果作为新的候选值加入队列。 5. 重复步骤4直到遍历完所有元素。 6. 当队列的大小超过k时,将队列中的最小值弹出。 7. 最后,队列中的所有候选值之和即为前k小的组合之和。 以下是使用优先队列解决HDU4546问题的代码示例: ```cpp #include <iostream> #include <vector> #include <queue> #include <functional> using namespace std; int main() { int n, k; cin >> n >> k; vector<int> a(n); for (int i = 0; i < n; i++) { cin >> a[i]; } sort(a.begin(), a.end()); // 对数组a进行排序 priority_queue<long long, vector<long long>, greater<long long>> pq; // 最小堆 pq.push(0); // 初始情况,前0个数的组合之和为0 for (int i = 0; i < n; i++) { long long num = pq.top(); // 取出当前队列中的最小值 pq.pop(); for (int j = i + 1; j <= n; j++) { pq.push(num + a[i]); // 将所有加和结果作为新的候选值加入队列 num += a[i]; } if (pq.size() > k) { pq.pop(); // 当队列大小超过k时,弹出最小值 } } long long sum = 0; while (!pq.empty()) { sum += pq.top(); // 求队列中所有候选值之和 pq.pop(); } cout << sum << endl; return 0; } ``` 使用优先队列的方法可以有效地找到前k小的组合之和,时间复杂度为O(nklog(k))。希望这个解法对你有所帮助!

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值